class marginal_IndivBotSetupClient extends UTIndivBotSetupClient;

function LoadBots()
{
	local class<ChallengeBotInfo> C;
	local int i;

	C = class<ChallengeBotInfo>(DynamicLoadObject("Botpack.ChallengeBotInfo", class'Class'));
	BotInfo = GetEntryLevel().Spawn(C);

	// Add the bots into the combo
	for(i=0;i<32;i++)
		BotCombo.AddItem(BotWord@string(i+1), String(i));
}

function LoadWeapons()
{
	local int NumWeaponClasses;
	local string NextWeapon, NextDesc;
	local string WeaponBaseClass;

	WeaponBaseClass = "TournamentWeapon";

	FavoriteWeaponCombo.AddItem(NoFavoriteWeapon, "None");

	GetPlayerOwner().GetNextIntDesc(WeaponBaseClass, 0, NextWeapon, NextDesc);
	while( (NextWeapon != "") && NumWeaponClasses < class'marginallyenhancedUT'.default.BotWeaponLimit )
	{
		FavoriteWeaponCombo.AddItem(NextDesc, NextWeapon);
		NumWeaponClasses++;
		GetPlayerOwner().GetNextIntDesc(WeaponBaseClass, NumWeaponClasses, NextWeapon, NextDesc);
	}
	FavoriteWeaponCombo.Sort();
}

function LoadClasses()
{
// And the master coder UsAaR33 said unto his apprentice Psychic_313,
	// screw BotInfo.AvailableClasses[]
// And lo, it was screwed.

	IteratePossibleBotClasses();
}

function IteratePossibleBotClasses()
{
	local String NextBotClass, NextBotDesc;
	local int SortWeight,NumClasses;
	NumClasses = 0;
	GetPlayerOwner().GetNextIntDesc("Bot", 0, NextBotClass, NextBotDesc);
	while ( (NextBotClass != "") && NumClasses < class'marginallyenhancedUT'.default.BotClassLimit )
	{
		NumClasses++;
		ClassCombo.AddItem(NextBotDesc, NextBotClass, SortWeight);
		GetPlayerOwner().GetNextIntDesc("Bot", NumClasses, NextBotClass, NextBotDesc);
	}
	ClassCombo.Sort();
}

function IterateVoices()
{
	local int NumVoices;
	local string NextVoice, NextDesc;
	local string VoicepackMetaClass;
	local bool OldInitialized;

	OldInitialized = Initialized;
	Initialized = False;
	VoicePackCombo.Clear();
	Initialized = OldInitialized;

	if(ClassIsChildOf(NewPlayerClass, class'Bot'))
		VoicePackMetaClass = class<Bot>(NewPlayerClass).default.VoicePackMetaClass;
	else
		VoicePackMetaClass = "Botpack.ChallengeVoicePack";

	// Load the base class into memory to prevent GetNextIntDesc crashing as the class isn't loadded.
	DynamicLoadObject(VoicePackMetaClass, class'Class');

	GetPlayerOwner().GetNextIntDesc(VoicePackMetaClass, 0, NextVoice, NextDesc);
	while (NextVoice != "" && NumVoices < class'marginallyenhancedUT'.default.BotVoiceLimit)
	{
		if(NextVoice ~=  "Botpack.VoiceBoss")
			VoicePackCombo.AddItem(NextDesc, "Botpack.VoiceBotBoss", 0);
		else
			VoicePackCombo.AddItem(NextDesc, NextVoice, 0);

		NumVoices++;
		GetPlayerOwner().GetNextIntDesc(VoicePackMetaClass, NumVoices, NextVoice, NextDesc);
	}

	VoicePackCombo.Sort();
}

function IterateSkins()
// Psychic_313: allowed descriptions for non-bIsMultiSkinned skins; possibly speeded up INT processing a bit for
// multiskinned models
{
	local string SkinName, SkinDesc, TestName, Temp, FaceName;
	local int i;
	local bool bNewFormat;

	SkinCombo.Clear();

	if( ClassIsChildOf(NewPlayerClass, class'Spectator') )
	{
		SkinCombo.HideWindow();
		return;
	}
	else
		SkinCombo.ShowWindow();

	bNewFormat = NewPlayerClass.default.bIsMultiSkinned;

	SkinName = "None";
	TestName = "";
	while ( i < class'marginallyenhancedUT'.default.BotTextureLimit )
	{
		i++;
		GetPlayerOwner().GetNextSkin(MeshName, SkinName, 1, SkinName, SkinDesc);

		if( SkinName == TestName )
			break;

		if( TestName == "" )
			TestName = SkinName;

		if( !bNewFormat )
		{
			Temp = GetPlayerOwner().GetItemName(SkinName);
			if( Left(Temp, 2) != "T_" )
				if( SkinDesc == "" )
					SkinCombo.AddItem(Temp, SkinName);
				else
					SkinCombo.AddItem(SkinDesc, SkinName);
		}
		else
		{
			// Multiskin format
			if( SkinDesc != "")
			{
				Temp = GetPlayerOwner().GetItemName(SkinName);
				// if(Len(Temp) < 5) <-- this breaks?!
				if(Mid(Temp, 5, 64) == "")
				{
					// This is a skin
					SkinCombo.AddItem(SkinDesc, Left(SkinName, Len(SkinName) - Len(Temp)) $ Left(Temp, 4));
				}
			}
		}
	}
	SkinCombo.Sort();
}

defaultproperties
{
     AccuracyHelp="Change this bot's weapon accuracy. NOTE: this has a *very* big effect on the bot's overall skill."
}
